﻿-- raid panel

function nUI:createRaidInfo()
	
	nUI.raid_frame = CreateFrame( "Frame", "nUI_RaidFrame", nUI.info_frame );
	nUI.raid_frame:SetWidth( (nUI.info_frame:GetWidth()-3) * 3 );
	nUI.raid_frame:SetHeight( (nUI.info_frame:GetHeight()-3) * 3 );
	nUI.raid_frame:SetScale( 1/3 );
	nUI.raid_frame:SetPoint( "CENTER", nUI.info_frame, "CENTER", 0, 0 );
	nUI.raid_frame.group = {};

	nUI:addInfoMode( "Raid", function() nUI.raid_frame:Show(); end, function() nUI.raid_frame:Hide(); end );
	
	local unit_height = nUI.raid_frame:GetHeight() / 8 + 4;
	local unit_width  = (nUI.raid_frame:GetWidth() - 20) / 5;
	local raid_layout =
	{
		name               = "nUI_RaidInfo",
		class_colors       = "yes",
		orientation        = "left",
		show_detail        = "no",
		show_border        = "no",
		
		Portrait =
		{
			visible   = "no",
		},
		StatusBars =
		{
			visible = "yes",
			spell   = "none",
			percent = "none",
			values  = "none",
			total   = "none",
		},
		Size =
		{
			width         = unit_width,
			height        = unit_height,
			compact       = "yes",
		},
		Origin =
		{
			anchor      = "BOTTOMLEFT",
		},
	};
	
	for i=1,8 do
		
		local raid_group = CreateFrame( "Frame", "$parent_Group"..i, nUI.raid_frame );
		
		nUI.raid_frame.group[i] = raid_group;
		
		raid_group:SetWidth( nUI.raid_frame:GetWidth() );
		raid_group:SetHeight( unit_height - 4 );
		raid_group.unit = {};
	
		raid_group.label = raid_group:CreateFontString( "$parentLabel" );
		raid_group.label:SetPoint( "LEFT", raid_group, "LEFT", 0, 0 );
		raid_group.label:SetFont( "Fonts\\ARIALN.TTF", unit_height * 0.5, "OUTLINE" );
		raid_group.label:SetJustifyH( "LEFT" );
		raid_group.label:SetJustifyV( "MIDDLE" );
		raid_group.label:SetTextColor( 1, 0.83, 0, 1 );
		raid_group.label:SetText( i );
		
		if i == 1 then raid_group:SetPoint( "TOPLEFT", nUI.raid_frame, "TOPLEFT", 0, 0 );
		else raid_group:SetPoint( "TOP", nUI.raid_frame.group[i-1], "BOTTOM", 0, 0 );
		end
		
		local last_unit = nil;
		
		for j=1,5 do
			
			raid_layout.id   = (i-1) * 5 + j;
			local id         = "raid"..raid_layout.id;
			local new_layout = nUI.Class.UnitLayout:new( id, raid_layout );
			local unit       = nUI.Class.Unit:new( raid_group, raid_layout.id, new_layout );
			
			raid_group.unit[j] = unit;
			
			unit:ClearAllPoints();
			unit:setHighlightAgro();
			
			if j == 1 then unit:SetPoint( "LEFT", raid_group, "LEFT", 10, 1 );
			else unit:SetPoint( "LEFT", last_unit.frame, "RIGHT", 0, 0 );
			end
		
			last_unit = unit;
		end
	
	end
end
